/* $Log:	xhchat.h,v $
 * Revision 2.9  92/12/13  15:20:20  kdh
 * new options: idle-colors
 *              bell in xhchat
 *              automatic toplevel width (font width)
 *              dynamic column number
 *              activity light
 * 
 * Revision 2.8  92/12/10  12:37:59  kdh
 * some bug fixes
 * activity light
 * 
 *
 */
/*

Copyright (C) 1992 Klaus Hartenstein

Permission to use, copy, modify, and distribute this software and its
documentation for any purpose and without fee is hereby granted, provided
that the above copyright notice appear in all copies and that both that
copyright notice and this permission notice appear in supporting
documentation.  This software is provided "as is" without express or
implied warranty.

*/

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Label.h>
#include <X11/Shell.h>
#include <stdio.h>

static String fallback_res[]={
  "*Scrollbar*thickness:10",
  "*Text*foreground: blue",
  "*Text*background: grey90",
  NULL};

extern void KeyUpAction();
extern void KeyDownAction();

static XtActionsRec text_actions[]={
  {"key-up",KeyUpAction},
  {"key-down",KeyDownAction},
  NULL
  };


static String txt_trans="<Key>Up:previous-line()\n\
<Key>Down:  next-line()\n\
<Key>Left:  backward-character()\n\
<Key>Right: forward-character()\n\
Ctrl<Key>A: beginning-of-line()\n\
Ctrl<Key>E: end-of-line()\n\
<Btn1Down>: select-start()\n\
<Btn1Motion>: extend-adjust()\n\
<Btn1Up>    : extend-end(PRIMARY, CUT_BUFFER0)\n\
<Btn3Down>  : extend-start()\n\
<Btn3Up>    : extend-end(PRIMARY, CUT_BUFFER0)\n\
<Btn3Motion>: extend-adjust()\n\
Ctrl<Key>S  : search(forward)\n\
Ctrl<Key>R  : search(backward)\n\
<KeyDown>   : key-down()\n\
<KeyUp>     : key-up()";

static String drain_txt_trans="<Btn1Down>: select-start()\n\
<Btn1Motion>: extend-adjust()\n\
<Btn1Up>    : extend-end(PRIMARY, CUT_BUFFER0)\n\
<Btn3Down>  : extend-start()\n\
<Btn3Up>    : extend-end(PRIMARY, CUT_BUFFER0)\n\
<Btn3Motion>: extend-adjust()";



XtAppContext app_con_xhchat;
Display *d1,  *d2;
Widget top1,  top2,  form1,  form2, 
  source1,  source2,  drain1,  drain2, 
  paned1,  paned2,  box1,  box2,  cmd;

#define NONE    0
#define CTRL_D  1
#define CTRL_K  2 
#define CTRL_P  3  
#define CTRL_N  4  
#define CTRL_F  5  
#define CTRL_B  6
#define META    7 
#define RETURN  8
#define DEL     9
#define BS      10
#define RET     11
#define OTHER   12
#define RIGHT   13
#define LEFT    14
#define UP      15
#define DOWN    16
#define CTRL_C  17
#define NORM    100
#define PRESS   101
#define RELEASE 102
#define SOURCE1 103
#define SOURCE2 104


Boolean Cntrl = False;
Boolean Meta  = False;

char *username;
char labelstring[256];

#define lbl_width 100
#define lbl_height 10
static char lbl_bits[] = {
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0xe0, 0x70, 0xc3, 0x78, 0x86, 0x61, 0xfc, 0x03, 0x00,
   0x00, 0x00, 0x00, 0x00, 0xc0, 0x39, 0xc3, 0x7c, 0x86, 0x61, 0xfc, 0x03,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x1c, 0xc3, 0x0e, 0x86, 0xf1, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0xdb, 0x06, 0xb6, 0xf1,
   0x60, 0x40, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xdb, 0x06, 0xb6,
   0x99, 0x61, 0x60, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x80, 0x13, 0xc3, 0x0e,
   0x86, 0x99, 0x61, 0x40, 0x08, 0x00, 0x00, 0x00, 0x00, 0xc0, 0x39, 0xc3,
   0x7c, 0x86, 0x0d, 0x63, 0x40, 0x08, 0x00, 0x00, 0x00, 0x00, 0xe0, 0x70,
   0xc3, 0x78, 0x86, 0x0d, 0x63, 0x40, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00,
   0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

Pixmap lbl_1, lbl_2;

